Imports System.Runtime.Serialization

Public Class Form1
    Private Sub btnDivideByZero_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles btnDivideByZero.Click
        Throw New DivideByZeroException("This is a divide by zero exception")
    End Sub

    Private Sub btnInvalidWorkAssignmentException_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles btnInvalidWorkAssignmentException.Click
        Throw New InvalidWorkAssignmentException()
    End Sub
End Class

Public Class InvalidWorkAssignmentException
    Inherits Exception

    Public Sub New()
        MyBase.New("This work assignment is invalid")
    End Sub

    Public Sub New(ByVal msg As String)
        MyBase.New(msg)
    End Sub

    Public Sub New(ByVal msg As String, ByVal inner_exception As Exception)
        MyBase.New(msg, inner_exception)
    End Sub

    Public Sub New(ByVal info As SerializationInfo, ByVal context As StreamingContext)
        MyBase.New(info, context)
    End Sub
End Class